/*****************************************************************************
 * file    Inc/RS485_sensor.h 
 * author  YuLiang
 * version 1.0.0
 * date    17-Jun-2022
 * brief   This file provides all the headers of RS485 sensor function.
 ******************************************************************************
 * Attention
 *
 * <h2><center>&copy; COPYRIGHT(c) 2022 LandPower</center></h2>
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *   1. Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *   3. Neither the name of WTOE nor the names of its contributors may be used to 
 *      endorse or promote products derived from this software without specific
 *      prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************/

#ifndef __RS485_SENSOR_H__
#define __RS485_SENSOR_H__

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "FreeRTOS.h"
#include "task.h"
#include "cmsis_os.h"

/* Define --------------------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
typedef struct
{
    int16_t temp;
    uint16_t joint_attitude_x;
    uint16_t gravity_x_max;
    uint16_t gravity_x_min;
    uint16_t joint_attitude_y;
    uint16_t gravity_y_max;
    uint16_t gravity_y_min;
    uint16_t joint_attitude_z;
    uint16_t gravity_z_max;
    uint16_t gravity_z_min;
    uint8_t is_valid;
} sensor_value_t;

/* Exported macro ------------------------------------------------------------*/
/* Extern global variables ---------------------------------------------------*/
extern sensor_value_t sensor_value[SENSOR_SUM];
extern uint8_t sensor_short;

/* Extern functions ----------------------------------------------------------*/
extern void sensor_start(void);
extern void sensor_start_free(void);
extern void sensor_show(void);
#endif
/******************* (C) COPYRIGHT LandPower ***** END OF FILE ****************/
